- [Resource: StoragePool](https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools#StoragePool)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools#StoragePool.SCHEMA_REPRESENTATION)
- [Methods](https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools#METHODS_SUMMARY)

## Resource: StoragePool

Represents a zonal storage pool resource.

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "creationTimestamp": string, "name": string, "description": string, "poolProvisionedCapacityGb": string, "poolProvisionedIops": string, "poolProvisionedThroughput": string, "zone": string, "state": enum, "selfLink": string, "selfLinkWithId": string, "labels": { string: string, ... }, "labelFingerprint": string, "resourceStatus": { "lastResizeTimestamp": string, "diskCount": string, "poolUsedCapacityBytes": string, "poolUserWrittenBytes": string, "totalProvisionedDiskCapacityGb": string, "maxTotalProvisionedDiskCapacityGb": string, "poolUsedIops": string, "totalProvisionedDiskIops": string, "poolUsedThroughput": string, "totalProvisionedDiskThroughput": string, "exapoolMaxReadIops": string, "exapoolMaxWriteIops": string, "exapoolMaxReadThroughput": string, "exapoolMaxWriteThroughput": string }, "storagePoolType": string, "status": { "lastResizeTimestamp": string, "diskCount": string, "poolUsedCapacityBytes": string, "poolUserWrittenBytes": string, "totalProvisionedDiskCapacityGb": string, "maxTotalProvisionedDiskCapacityGb": string, "poolUsedIops": string, "totalProvisionedDiskIops": string, "poolUsedThroughput": string, "totalProvisionedDiskThroughput": string, "exapoolMaxReadIops": string, "exapoolMaxWriteIops": string, "exapoolMaxReadThroughput": string, "exapoolMaxWriteThroughput": string }, "capacityProvisioningType": enum, "performanceProvisioningType": enum, "exapoolProvisionedCapacityGb": { "writeOptimized": string, "readOptimized": string, "capacityOptimized": string }, "shareSettings": { "projectMap": { string: { "projectId": string }, ... } }, "params": { "resourceManagerTags": { string: string, ... } } } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#storagePool` for storage pools. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `name` | `string` Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash. |
| `description` | `string` An optional description of this resource. Provide this property when you create the resource. |
| `poolProvisionedCapacityGb` | `string (https://developers.google.com/discovery/v1/type-format format)` Size of the storage pool in GiB. For more information about the size limits, see <https://cloud.google.com/compute/docs/disks/storage-pools>. |
| `poolProvisionedIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Provisioned IOPS of the storage pool. Only relevant if the storage pool type is hyperdisk-balanced. |
| `poolProvisionedThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Provisioned throughput of the storage pool in MiB/s. Only relevant if the storage pool type is hyperdisk-balanced or hyperdisk-throughput. |
| `zone` | `string` Output only. URL of the zone where the storage pool resides. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body. |
| `state` | `enum` Output only. The status of storage pool creation. - `CREATING`: Storage pool is provisioning. storagePool. - `FAILED`: Storage pool creation failed. - `READY`: Storage pool is ready for use. - `DELETING`: Storage pool is deleting. <br /> |
| `selfLink` | `string` Output only. Server-defined fully-qualified URL for this resource. |
| `selfLinkWithId` | `string` Output only. Server-defined URL for this resource's resource id. |
| `labels` | `map (key: string, value: string)` Labels to apply to this storage pool. These can be later modified by the `setLabels` method. |
| `labelFingerprint` | `string (https://developers.google.com/discovery/v1/type-format format)` A fingerprint for the labels being applied to this storage pool, which is essentially a hash of the labels set used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to update or change labels, otherwise the request will fail with error `412 conditionNotMet`. To see the latest fingerprint, make a `get()` request to retrieve a storage pool. A base64-encoded string. |
| `resourceStatus` | `object` Output only. Status information for the storage pool resource. |
| `resourceStatus.lastResizeTimestamp` | `string` Output only. Timestamp of the last successful resize in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `resourceStatus.diskCount` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Number of disks used. |
| `resourceStatus.poolUsedCapacityBytes` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Space used by data stored in disks within the storage pool (in bytes). This will reflect the total number of bytes written to the disks in the pool, in contrast to the capacity of those disks. |
| `resourceStatus.poolUserWrittenBytes` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Amount of data written into the pool, before it is compacted. |
| `resourceStatus.totalProvisionedDiskCapacityGb` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned capacity (in GiB) in this storage pool. A disk's provisioned capacity is the same as its total capacity. |
| `resourceStatus.maxTotalProvisionedDiskCapacityGb` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed aggregate disk size in GiB. |
| `resourceStatus.poolUsedIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned IOPS, minus some amount that is allowed per disk that is not counted towards pool's IOPS capacity. For more information, see <https://cloud.google.com/compute/docs/disks/storage-pools>. |
| `resourceStatus.totalProvisionedDiskIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned IOPS. |
| `resourceStatus.poolUsedThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned throughput in MiB/s. |
| `resourceStatus.totalProvisionedDiskThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned throughput in MiB/s, minus some amount that is allowed per disk that is not counted towards pool's throughput capacity. |
| `resourceStatus.exapoolMaxReadIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed read IOPS for this Exapool. |
| `resourceStatus.exapoolMaxWriteIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed write IOPS for this Exapool. |
| `resourceStatus.exapoolMaxReadThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed read throughput in MiB/s for this Exapool. |
| `resourceStatus.exapoolMaxWriteThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed write throughput in MiB/s for this Exapool. |
| `storagePoolType` | `string` Type of the storage pool. |
| `status` | `object` Output only. Status information for the storage pool resource. |
| `status.lastResizeTimestamp` | `string` Output only. Timestamp of the last successful resize in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `status.diskCount` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Number of disks used. |
| `status.poolUsedCapacityBytes` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Space used by data stored in disks within the storage pool (in bytes). This will reflect the total number of bytes written to the disks in the pool, in contrast to the capacity of those disks. |
| `status.poolUserWrittenBytes` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Amount of data written into the pool, before it is compacted. |
| `status.totalProvisionedDiskCapacityGb` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned capacity (in GiB) in this storage pool. A disk's provisioned capacity is the same as its total capacity. |
| `status.maxTotalProvisionedDiskCapacityGb` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed aggregate disk size in GiB. |
| `status.poolUsedIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned IOPS, minus some amount that is allowed per disk that is not counted towards pool's IOPS capacity. For more information, see <https://cloud.google.com/compute/docs/disks/storage-pools>. |
| `status.totalProvisionedDiskIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned IOPS. |
| `status.poolUsedThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned throughput in MiB/s. |
| `status.totalProvisionedDiskThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Sum of all the disks' provisioned throughput in MiB/s, minus some amount that is allowed per disk that is not counted towards pool's throughput capacity. |
| `status.exapoolMaxReadIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed read IOPS for this Exapool. |
| `status.exapoolMaxWriteIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed write IOPS for this Exapool. |
| `status.exapoolMaxReadThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed read throughput in MiB/s for this Exapool. |
| `status.exapoolMaxWriteThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Maximum allowed write throughput in MiB/s for this Exapool. |
| `capacityProvisioningType` | `enum` Provisioning type of the byte capacity of the pool. |
| `performanceProvisioningType` | `enum` Provisioning type of the performance-related parameters of the pool, such as throughput and IOPS. |
| `exapoolProvisionedCapacityGb` | `object` Provisioned capacities for each SKU for this Exapool in GiB |
| `exapoolProvisionedCapacityGb.writeOptimized` | `string (https://developers.google.com/discovery/v1/type-format format)` Size, in GiB, of provisioned write-optimized capacity for this Exapool |
| `exapoolProvisionedCapacityGb.readOptimized` | `string (https://developers.google.com/discovery/v1/type-format format)` Size, in GiB, of provisioned read-optimized capacity for this Exapool |
| `exapoolProvisionedCapacityGb.capacityOptimized` | `string (https://developers.google.com/discovery/v1/type-format format)` Size, in GiB, of provisioned capacity-optimized capacity for this Exapool |
| `shareSettings` | `object` Share settings for the storage pool. |
| `shareSettings.projectMap[]` | `map (key: string, value: object)` A map of project id and project config. |
| `shareSettings.projectMap[].projectId` | `string` The project ID, should be same as the key of this project config in the parent map. |
| `params` | `object` Input only. Additional params passed with the request, but not persisted as part of resource payload. |
| `params.resourceManagerTags` | `map (key: string, value: string)` Input only. Resource manager tags to be bound to the storage pool. Tag keys and values have the same definition as [resource manager tags](https://cloud.google.com/resource-manager/docs/tags/tags-overview). Keys and values can be either in numeric format, such as `tagKeys/{tag_key_id}` and `tagValues/{tag_value_id}` or in namespaced format such as `{org_id|projectId}/{tag_key_short_name}` and `{tag_value_short_name}`. The field is ignored (both PUT \& PATCH) when empty. |

| ## Methods ||
|---|---|
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/aggregatedList` | Retrieves an aggregated list of storage pools. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/delete` | Deletes the specified storage pool. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/get` | Returns a specified storage pool. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/getIamPolicy` | Gets the access control policy for a resource. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/insert` | Creates a storage pool in the specified project using the data in the request. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/list` | Retrieves a list of storage pools contained within the specified zone. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/listDisks` | Lists the disks in a specified storage pool. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/setIamPolicy` | Sets the access control policy on the specified resource. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/testIamPermissions` | Returns permissions that a caller has on the specified resource. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/storagePools/update` | Updates the specified storagePool with the data included in the request. |